VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3030
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9300
   LinkTopic       =   "Form1"
   ScaleHeight     =   3030
   ScaleWidth      =   9300
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRemoveNumbers 
      Caption         =   "Remove Numbers"
      Height          =   495
      Left            =   4200
      TabIndex        =   2
      Top             =   1320
      Width           =   975
   End
   Begin VB.CommandButton cmdAddNumbers 
      Caption         =   "Add Numbers"
      Height          =   495
      Left            =   4200
      TabIndex        =   1
      Top             =   600
      Width           =   975
   End
   Begin VB.ListBox List1 
      Height          =   2205
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const LB_SETTABSTOPS = &H192

Private DbFile As String

' List the data.
Private Sub ListData()
Dim conn As ADODB.Connection
Dim rs As ADODB.Recordset
Dim txt As String
Dim fld As Field

    ' Open the Connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & DbFile & ";" & _
        "Persist Security Info=False"
    conn.Open

    ' Open the Recordset.
    Set rs = New ADODB.Recordset
    rs.Open Source:="Books", _
        ActiveConnection:=conn, _
        CursorType:=adOpenDynamic, _
        LockType:=adLockOptimistic

    ' List the data.
    List1.Clear
    Do While Not rs.EOF
        txt = ""
        For Each fld In rs.Fields
            txt = txt & Trim$(fld.Value) & vbTab
        Next fld
        If Len(txt) > 0 Then txt = Left$(txt, Len(txt) - 1)
        List1.AddItem txt

        rs.MoveNext
    Loop

    rs.Close
    conn.Close
End Sub
' Add a number to the beginning of each book title.
Private Sub cmdAddNumbers_Click()
Dim conn As ADODB.Connection
Dim rs As ADODB.Recordset
Dim num As Integer

    ' Open the Connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & DbFile & ";" & _
        "Persist Security Info=False"
    conn.Open

    ' Open the Recordset.
    Set rs = New ADODB.Recordset
    rs.Open Source:="Books", _
        ActiveConnection:=conn, _
        CursorType:=adOpenDynamic, _
        LockType:=adLockOptimistic

    ' List the data.
    num = 1
    Do While Not rs.EOF
        ' See if the title already includes a period.
        If InStr(rs!Title, ".") = 0 Then
            ' Add a number to the book title.
            rs!Title = Format$(num) & ". " & rs!Title
            rs.Update
        End If

        ' Move to the next record.
        num = num + 1
        rs.MoveNext
    Loop

    rs.Close
    conn.Close

    ' Redisplay the new data.
    ListData
End Sub
' Remove numbers from the beginning of each book title.
Private Sub cmdRemoveNumbers_Click()
Dim conn As ADODB.Connection
Dim rs As ADODB.Recordset
Dim pos As Integer

    ' Open the Connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & DbFile & ";" & _
        "Persist Security Info=False"
    conn.Open

    ' Open the Recordset.
    Set rs = New ADODB.Recordset
    rs.Open Source:="Books", _
        ActiveConnection:=conn, _
        CursorType:=adOpenDynamic, _
        LockType:=adLockOptimistic

    ' List the data.
    Do While Not rs.EOF
        ' Find the . after the number.
        pos = InStr(rs!Title, ".")

        ' Remove the . and the following space.
        If pos > 0 Then
            rs!Title = Mid$(rs!Title, pos + 2)
            rs.Update
        End If

        ' Move to the next record.
        rs.MoveNext
    Loop

    rs.Close
    conn.Close

    ' Redisplay the new data.
    ListData
End Sub
Private Sub Form_Load()
Dim tabs(2) As Long

    ' Set tabs in the ListBox.
    tabs(1) = 20
    tabs(2) = 150

    ' Set the tabs.
    SendMessage List1.hwnd, LB_SETTABSTOPS, 2, tabs(1)

    ' Get the data file name.
    DbFile = App.Path
    If Right$(DbFile, 1) <> "\" Then DbFile = DbFile & "\"
    DbFile = DbFile & "books.mdb"

    ' Display the initial data.
    ListData
End Sub
Private Sub Form_Resize()
    cmdAddNumbers.Left = ScaleWidth - cmdAddNumbers.Width - 30
    cmdRemoveNumbers.Left = cmdAddNumbers.Left
    List1.Move 0, 0, cmdAddNumbers.Left - 30, ScaleHeight
End Sub
